Bug 30425 - Making Icon Themes is Far too Difficult
Summary: Making Icon Themes is Far too Difficult
Status: RESOLVED WORKSFORME
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: LibreOffice (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: Other All
: medium enhancement
Assignee: Not Assigned
URL:
Whiteboard: target:5.0.0
Keywords:
Depends on: 63962
Blocks: Icon-Themes
  Show dependency treegraph
 
Reported: 2010-09-28 09:03 UTC by Andrew
Modified: 2017-05-26 18:58 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Andrew 2010-09-28 09:03:59 UTC
The way that LibreOffice packages its icon themes if far too complex and difficult and therefore stifles creativity when it comes to creating new icon themes.

Icon are given cryptic names such as envvl_l.png in cryptic directories such as sw/res and therefore an artist has to spend more time working out where an icon should go, rather than creating a theme.

I propose that a readable naming scheme should be put in place that fixes this, maybe something similar to what GTK uses at the moment?

As well as this, only icon should be distributed in a theme package, not unnecessary files such as go-oo-team.png :) These should be packaged with LibreOffice, not in the icon theme package.

Thanks :)
Comment 1 Katarina Behrens 2010-09-29 02:15:45 UTC
This sounds like a new feature request. Assigned to Kendy to decide who's going to take care
Comment 2 Jan Holesovsky 2010-10-29 17:26:02 UTC
Andrew: Do I understand it correctly that your are an artist actually interested in creating, or improving an icon theme?  Would be great to meet you on our IRC - irc.freenode.net, channel #libreoffice.  Poke me there - I am 'kendy', I think it would be good to talk about this a bit.

I am moving the points you raised to Easy Hacks:

http://wiki.documentfoundation.org/Development/Easy_Hacks#Give_the_icons_reasonable_names
Comment 3 Bob Harvey 2011-01-29 03:53:39 UTC
Is this a good time to mention http://www.openoffice.org/issues/show_bug.cgi?id=18829 ? , which still has 107 votes and which dates back to 2003.
Comment 4 Björn Michaelsen 2011-07-21 07:41:40 UTC
==== Give the icons reasonable names ====

'''Background:''' [https://bugs.freedesktop.org/show_bug.cgi?id=30425 fdo#30425#]

Icon are given cryptic names such as envvl_l.png in cryptic directories such as sw/res and therefore an artist has to spend more time working out where an icon should go, rather than creating a theme. The proposal is that a readable naming scheme should be put in place. Ideally, if the names of the main icons are the same as eg. in Gnome. The process of documentation and planning has begun here: [[Development/Icon Themes|Icon Themes]]. Any coding effort can be supported by ace_dent.

'''Skills: '''build, trivial C++, searching in opengrok
Comment 5 Jan Holesovsky 2012-10-10 14:44:12 UTC
To be able to do this, you need to first find the icon in .src file.  Eg. for icon-themes/galaxy/sw/res/envvl_l.png, it must be in the 'sw' subdir (galaxy is name of the theme).  So do:

git grep envvl_l sw

it will tell you

sw/source/ui/envelp/envprt.src:    File = "envvl_l.bmp" ;

Now you can open that .src file, change the name of the icon there, and then

git mv icon-themes/galaxy/sw/res/envvl_l.png icon-themes/galaxy/sw/res/newname.png

NOTE: You have to do the 'git mv' for every icon theme!

NOTE: For icons that are named like blah0123.png, it makes no sense to try to rename them, they are part of ImageLists, the 'blah' is a prefix there, and the number has to stay.  You can get them a better prefix, but that is all at the moment.
Comment 6 Björn Michaelsen 2013-10-04 18:47:23 UTC
adding LibreOffice developer list as CC to unresolved EasyHacks for better visibility.

see e.g. http://nabble.documentfoundation.org/minutes-of-ESC-call-td4076214.html for details
Comment 7 ace_dent 2014-02-06 21:09:29 UTC
...
Comment 8 ace_dent 2014-02-15 10:05:48 UTC
Proposed workflow, taking advantage of links.txt to remap icon references at runtime:

After creating a canonical icon, and searching source for references to the duplicate .png icon file…

1. No reference found in source:
- ICON 	- Delete redundant png file.
- SOURCE - No action required.
- LINKS - aLink - Remove any old links. Add link to canonical icon to be safe. Tag: '#unreferenced' for future removal.
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'No source reference found for icon. Complete link removal after further investigations'.

2. Referenced only by full path:
- ICON 	- Delete redundant png file.
- SOURCE - Modify source reference, so that the full path points to new canonical icon.
- LINKS - aLink - Remove any old links (every theme should have the canonical icon, or fallback to Galaxy icon thru packimages build script).
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - None required.

3. Referenced by .uno:Controller:
- ICON 	- Delete redundant png file.
- SOURCE - Do not change any .uno:Command function names or code. Safe to modify other source references with the full path to the canonical icon. 
- LINKS - aLink - Remove any old links. Add link to canonical icon. Tag: '#command123', where '123' is the number of uno references found (for sorting).
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'Referenced by .uno:Command. Icon name maintained through links.txt'.

4. Referenced by ImageList index:
- ICON 	- Delete redundant png file.
- SOURCE - Do not change any index numbers, reference or code. Safe to modify other source references with the full path to the canonical icon. 
- LINKS - aLink - Remove any old links. Add link to canonical icon. Tag: '#imagelist', for future fixing / removal.
- LINKS - aOriginal - Replace any references, to point to the canonical icon.
- LOG - Note: 'Referenced by ImageList index. Icon name maintained through links.txt'.

It is unlikely an icon will fall under both types 3 & 4.

Also... 
- Fix Copyright notices to include new Canonical name after original, i.e. 'X.png' becomes 'X.png (> Y.png)'. CopyrightsHuman CopyrightsTango CopyrightsOxygen.
- Change any references in helpcontent2 (Modify source reference, so that the full path points to new canonical icon.)
- Fix filenames of SVG files and inside(?) (e.g 'select.svg' inside 'Select.SVG' ?).
- Other references within svg files used to build icon sets.

Push to Gerrit:
1) Main changes to LibO source.
2) Updates to helpcontent2
Pull request on Github:
3) SVG (& links.txt?) changes to Sifr theme
4) SVG & links.txt changes to Tango-experimental theme
Comment 9 Commit Notification 2014-07-27 03:54:40 UTC
Martin Owens committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=70599252873c3dbe03e36083ad093aedfdb8b923

fdo#30425 - button should be print, not print preview



The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2014-07-30 18:43:20 UTC
Martin Owens committed a patch related to this issue.
It has been pushed to "libreoffice-4-3":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=995fd28f88a5122d4f649f7710501bcd752cf6b5&h=libreoffice-4-3

fdo#30425 - button should be print, not print preview


It will be available in LibreOffice 4.3.1.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Adolfo Jayme 2014-07-30 23:56:19 UTC
The above patches are unrelated to this bug; it seems Martin got the bug number wrong. Removing “target” tags from whiteboard.
Comment 12 QA Administrators 2014-10-23 17:31:44 UTC Comment hidden (obsolete)
Comment 14 Commit Notification 2015-02-23 21:29:55 UTC
Andrew committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=b940df4d1901a912acde714932387d1d8b5c3ec7

tdf#30425 Remove old icons -2

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 15 Commit Notification 2015-02-26 09:34:17 UTC
Andrew committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=945e8c4f5a377d328afdafe1410609a3ad1e7425

tdf#30425 Remove old icons -2

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 16 Robinson Tryon (qubit) 2015-12-14 06:55:02 UTC Comment hidden (obsolete)
Comment 17 Samuel Mehrbrodt (CIB) 2016-02-02 11:34:43 UTC
This task is a bit oversized for an EasyHack as it requires lots of understanding how icons are used in LO.
If anything, this should be broken down to smaller parts.
Comment 18 Yousuf Philips (jay) (retired) 2016-08-06 12:44:26 UTC
I recently went through the icon folder structure when breeze was added as a new icon theme and created this google doc explained what icons were contained in the various folders.

https://docs.google.com/document/d/1d5J162qviAQ3cJs6pm3g7XLKQ1y32QEq69lh7nwARoU/edit?usp=sharing
Comment 19 Yousuf Philips (jay) (retired) 2017-05-26 18:58:25 UTC
As icon names are named after their uno commands, or linked to other icons in links.txt, it isnt a difficult process to create new icon themes if designers are interested in taking on the task, as we recently did with breeze, or other icon designers are doing outside of LO.

https://www.gnome-look.org/p/1012295/
https://www.gnome-look.org/p/1012041/
http://charliecnr.deviantart.com/art/Office-2013-theme-for-LibreOffice-512127527